Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -7736,34 +7773,31 @@
                 copied = nxr
              ENDIF
-             
+
               DO  i = ss, ee
                 DO  j = nysg, nyng
-                   DO  k = nzb+1, nzt             
-                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
                       sq(k,j,i) = sq(k,j,copied) * flag
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           ELSE
-             WRITE(message_string,*)                                           &
-                                 'unknown decycling method: decycle_method (', &
-                     boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
-             CALL message( 'salsa_boundary_conds_decycle', 'SA0029',           &
-                           1, 2, 0, 6, 0 )
+             WRITE(message_string,*) 'unknown decycling method: decycle_method (', boundary,       &
+                                     ') ="' // TRIM( decycle_method(boundary) ) // '"'
+             CALL message( 'salsa_boundary_conds_decycle', 'PA0626', 1, 2, 0, 6, 0 )
           ENDIF
        ENDDO
     ENDIF
-    
+
 !
 !-- South and north boundaries
      IF ( decycle_ns  .AND.  ( bc_ns_cyc  .OR. bc_ns == 'nested' ) )  THEN
-    
+
        DO  boundary = 3, 4
 
           IF ( decycle_method(boundary) == 'dirichlet' )  THEN
-!    
-!--          Initial profile is copied to ghost and first three layers          
+!
+!--          Initial profile is copied to ghost and first three layers
              ss = 1
              ee = 0
@@ -7775,19 +7809,18 @@
                 ee = nyng
              ENDIF
-             
+
              DO  i = nxlg, nxrg
                 DO  j = ss, ee
-                   DO  k = nzb+1, nzt             
-                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
                       sq(k,j,i) = sq_init(k) * flag
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           ELSEIF ( decycle_method(boundary) == 'neumann' )  THEN
 !
-!--          The value at the boundary is copied to the ghost layers to simulate
-!--          an outlet with zero gradient
+!--          The value at the boundary is copied to the ghost layers to simulate an outlet with 
+!--          zero gradient
              ss = 1
              ee = 0
@@ -7801,25 +7834,22 @@
                 copied = nyn
              ENDIF
-             
+
               DO  i = nxlg, nxrg
                 DO  j = ss, ee
-                   DO  k = nzb+1, nzt             
-                      flag = MERGE( 1.0_wp, 0.0_wp,                            &
-                                    BTEST( wall_flags_0(k,j,i), 0 ) )
+                   DO  k = nzb+1, nzt
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
                       sq(k,j,i) = sq(k,copied,i) * flag
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           ELSE
-             WRITE(message_string,*)                                           &
-                                 'unknown decycling method: decycle_method (', &
-                     boundary, ') ="' // TRIM( decycle_method(boundary) ) // '"'
-             CALL message( 'salsa_boundary_conds_decycle', 'SA0030',           &
-                           1, 2, 0, 6, 0 )
+             WRITE(message_string,*) 'unknown decycling method: decycle_method (', boundary,       &
+                                     ') ="' // TRIM( decycle_method(boundary) ) // '"'
+             CALL message( 'salsa_boundary_conds_decycle', 'PA0627', 1, 2, 0, 6, 0 )
           ENDIF
        ENDDO
-    ENDIF   
- 
+    ENDIF
+
  END SUBROUTINE salsa_boundary_conds_decycle
 
@@ -7834,31 +7864,61 @@
 
     IMPLICIT NONE
-    
-    CHARACTER(len=*), INTENT(in) ::  itype !< 'dry' or 'wet'
+
+    CHARACTER(len=*), INTENT(in) ::  itype  !< 'dry' or 'wet'
+
+    INTEGER(iwp) ::  ic                 !< loop index for mass bin number
+    INTEGER(iwp) ::  iend               !< end index: include water or not
+
     INTEGER(iwp), INTENT(in) ::  ibin   !< index of the chemical component
     INTEGER(iwp), INTENT(in) ::  i      !< loop index for x-direction
-    INTEGER(iwp), INTENT(in) ::  j      !< loop index for y-direction 
-    REAL(wp), DIMENSION(:), INTENT(out) ::  mconc     !< total dry or wet mass 
-                                                      !< concentration
-                                                      
-    INTEGER(iwp) ::  c                  !< loop index for mass bin number
-    INTEGER(iwp) ::  iend               !< end index: include water or not     
-    
+    INTEGER(iwp), INTENT(in) ::  j      !< loop index for y-direction
+
+    REAL(wp), DIMENSION(:), INTENT(out) ::  mconc  !< total dry or wet mass concentration
+
 !-- Number of components 
     IF ( itype == 'dry' )  THEN
-       iend = get_n_comp( prtcl ) - 1 
+       iend = prtcl%ncomp - 1 
     ELSE IF ( itype == 'wet' )  THEN
-       iend = get_n_comp( prtcl ) 
+       iend = prtcl%ncomp
     ELSE
-       STOP 1 ! "INFO for Developer: please use the message routine to pass the output string" bin_mixrat: Error in itype
+       message_string = 'Error in itype!'
+       CALL message( 'salsa_mod: bin_mixrat', 'PA0628', 2, 2, 0, 6, 0 )
     ENDIF
 
     mconc = 0.0_wp
-    
-    DO c = ibin, iend*nbins+ibin, nbins !< every nbins'th element
-       mconc = mconc + aerosol_mass(c)%conc(:,j,i)
+
+    DO  ic = ibin, iend*nbins_aerosol+ibin, nbins_aerosol !< every nbins'th element
+       mconc = mconc + aerosol_mass(ic)%conc(:,j,i)
     ENDDO
-    
- END SUBROUTINE bin_mixrat 
+
+ END SUBROUTINE bin_mixrat
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sets surface fluxes
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_emission_update
+
+    USE control_parameters,                                                                        &
+        ONLY:  time_since_reference_point
+
+    IMPLICIT NONE
+
+    IF ( time_since_reference_point >= skip_time_do_salsa  )  THEN
+
+       IF ( next_aero_emission_update <= time_since_reference_point )  THEN
+          CALL salsa_emission_setup( .FALSE. )
+       ENDIF
+
+       IF ( next_gas_emission_update <= time_since_reference_point )  THEN
+          IF ( salsa_emission_mode == 'read_from_file'  .AND.  .NOT. salsa_gases_from_chem )  THEN
+             CALL salsa_gas_emission_setup( .FALSE. )
+          ENDIF
+       ENDIF
+
+    ENDIF
+
+ END SUBROUTINE salsa_emission_update
 
 !------------------------------------------------------------------------------!
